import { BaseLetsEncryptClient, BaseLetsEncryptOptions } from './letsEncrypt';
/**
 * This is the specific interface for the Self-signed options.
 */
export interface LetsEncryptSelfSignedOptions extends BaseLetsEncryptOptions {
    country: string;
    state: string;
    locality: string;
    organizationName: string;
}
export declare class LetsEncryptUsingSelfSigned extends BaseLetsEncryptClient {
    private country;
    private state;
    private locality;
    private organizationName;
    callCount: number;
    constructor(options: LetsEncryptSelfSignedOptions);
    /**
     * This is the method that overrides the base class method
     */
    protected getNewCertificate: (host: string, production: boolean, email: string) => Promise<boolean>;
}
