/// <reference types="node" />
import http from 'http';
import URL from 'url';
export interface ProxyUrl extends Partial<URL.Url> {
    useTargetHostHeader?: boolean;
    secure?: boolean;
}
export declare const makeUrl: (url: string | ProxyUrl) => ProxyUrl;
export declare const prependHttpIfRequired: (link: string) => string;
export declare const startsWith: (input: string, str: string) => boolean;
export declare const respondNotFound: (req: http.IncomingMessage, res: http.ServerResponse) => void;
/**
 * The timeout in node is only good for about 24 days.
 *
 * Certificates routinely expire over the span of months.
 *
 * The long timeout fires internally once a day until the last
 * day and then fires the external callback when the time has finally
 * expired
 */
export declare class LongTimeout {
    private expiration;
    private timer;
    private callbackArgs;
    private callback;
    constructor(callback: (...args: any[]) => void, expiration: number | Date, ...callbackArgs: any[]);
    private timerFired;
    private setTimer;
    clearTimer: () => void;
}
export declare const setLongTimeout: (callback: (...args: any[]) => void, expiration: number | Date) => LongTimeout;
export declare const clearLongTimeout: (timeout: LongTimeout) => void;
